## kdevelop 5.0.3

=== CMakeLists.txt ===
# KDevelop version
set( KDEVELOP_VERSION_MAJOR 5 )
set( KDEVELOP_VERSION_MINOR 0 )
set( KDEVELOP_VERSION_PATCH 3 )
set( KDEVELOP_VERSION "${KDEVELOP_VERSION_MAJOR}.${KDEVELOP_VERSION_MINOR}.${KDEVELOP_VERSION_PATCH}" )

################################################################################

cmake_minimum_required(VERSION 2.8.12)

project(KDevelop)

# we need some parts of the ECM CMake helpers
find_package (ECM 0.0.9 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${KDevelop_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDECompilerSettings NO_POLICY_SCOPE) # needs to be first, as set policies influence following macros
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMPackageConfigHelpers)

include(CTest)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)

include(KDEInstallDirs)
include(KDECMakeSettings)

set(QT_MIN_VERSION "5.4.0")
find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Widgets Concurrent Quick QuickWidgets WebKitWidgets Test)
set(KF5_DEP_VERSION "5.15.0") # we need KCrash::initialize
find_package(KF5 ${KF5_DEP_VERSION} REQUIRED COMPONENTS
  Config
  Declarative
  DocTools
  IconThemes
  I18n
  ItemModels
  ItemViews
  JobWidgets
  KCMUtils
  KIO
  NewStuff
  NotifyConfig
  Parts
  Service
  TextEditor
  ThreadWeaver
  XmlGui
  WindowSystem
  Crash
)
find_package(KF5SysGuard)
set_package_properties(KF5SysGuard PROPERTIES
    PURPOSE "Framework for process listing. Required for the 'Attach to Process' feature"
)
find_package(KDevelop-PG-Qt 1.90.90)
set_package_properties(KDevelop-PG-Qt PROPERTIES
    PURPOSE "KDevelop parser generator library. Required for the QMake Builder/Manager plugin."
)

find_package(KDevPlatform ${KDEVELOP_VERSION} REQUIRED)

add_definitions(
    -DQT_DEPRECATED_WARNINGS
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050400
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_STRICT_ITERATORS
    -DQT_USE_FAST_CONCATENATION
    -DQT_USE_FAST_OPERATOR_PLUS
)

# Turn off missing-field-initializers warning to avoid noise from false positives with empty {}
# See discussion: http://mail.kde.org/pipermail/kdevelop-devel/2014-February/046910.html
check_cxx_compiler_flag(-Wno-missing-field-initializers HAVE_MFI_FLAG)
check_cxx_compiler_flag(-Werror=undefined-bool-conversion HAVE_UBC_FLAG)
check_cxx_compiler_flag(-Werror=tautological-undefined-compare HAVE_TUC_FLAG)
if (HAVE_MFI_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
endif()
if (HAVE_UBC_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=undefined-bool-conversion")
endif()
if (HAVE_TUC_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=tautological-undefined-compare")
endif()

include_directories(${KDevelop_SOURCE_DIR} ${KDevelop_BINARY_DIR}  )

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
if(CMAKE_BUILD_TYPE_TOLOWER MATCHES "debug"
  OR CMAKE_BUILD_TYPE_TOLOWER STREQUAL "")
  set(COMPILER_OPTIMIZATIONS_DISABLED TRUE)
else()
  set(COMPILER_OPTIMIZATIONS_DISABLED FALSE)
endif()

# create config.h
configure_file (config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h )

add_subdirectory(pics)
add_subdirectory(app)
add_subdirectory(formatters)
add_subdirectory(languages)
add_subdirectory(projectbuilders)
add_subdirectory(projectmanagers)
add_subdirectory(debuggers)
add_subdirectory(app_templates)
add_subdirectory(documentation)
add_subdirectory(kdeintegration)
add_subdirectory(utils)
add_subdirectory(file_templates)
add_subdirectory(providers)
add_subdirectory(shortcuts)
add_subdirectory(doc)

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelop")
ecm_configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevelopConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
                                  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)
ecm_setup_version(${KDEVELOP_VERSION_MAJOR}.${KDEVELOP_VERSION_MINOR}.${KDEVELOP_VERSION_PATCH}
                  VARIABLE_PREFIX KDEVELOP
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
                  SOVERSION ${KDEVELOP_LIB_SOVERSION}
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevelop")
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install(EXPORT KDevelopTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" NAMESPACE KDev:: FILE KDevelopTargets.cmake)

# CTestCustom.cmake has to be in the CTEST_BINARY_DIR.
# in the KDE build system, this is the same as CMAKE_BINARY_DIR.
configure_file(${CMAKE_SOURCE_DIR}/CTestCustom.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake)

install(FILES org.kde.kdevelop.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

=== app/CMakeLists.txt ===
find_package(KF5Plasma)
set_package_properties(KF5Plasma PROPERTIES
    PURPOSE "Plasma libraries for enabling the plasma addons"
    URL "http://www.kde.org"
    TYPE OPTIONAL)
if(KF5Plasma_FOUND)
    add_subdirectory(plasma)
endif()

find_package(SharedMimeInfo REQUIRED)

option(KDEVELOP_SINGLE_APP "Use QtSingleApplication as KDevelop's base" OFF)

set(singleapp_SRCS qtlocalpeer.cpp qtsingleapplication.cpp qtlockedfile.cpp)
if(WIN32)
    set(singleapp_SRCS ${singleapp_SRCS} qtlockedfile_win.cpp)
else()
    set(singleapp_SRCS ${singleapp_SRCS} qtlockedfile_unix.cpp)
endif()

set(kdevelop_SRCS  main.cpp kdevideextension.cpp)
if(KDEVELOP_SINGLE_APP)
    set(kdevelop_SRCS ${kdevelop_SRCS} ${singleapp_SRCS})
endif()

#TODO: remove CMAKE_CURRENT_SOURCE_DIR prefix when ECM is fixed
set(kdevelop_ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/16-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/32-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/48-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/64-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/128-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/256-apps-kdevelop.png
)

ecm_install_icons(ICONS ${kdevelop_ICONS}
    DESTINATION ${ICON_INSTALL_DIR})
    
ecm_add_app_icon(kdevelop_SRCS ICONS
    ${kdevelop_ICONS})

qt5_add_resources(kdevelop_SRCS kdevelop.qrc)
add_executable(kdevelop ${kdevelop_SRCS} )

target_link_libraries(kdevelop
    KDev::Interfaces
    KDev::Shell
    KDev::Util

    KF5::Declarative
    KF5::IconThemes
    KF5::Crash
)
IF(APPLE)
    target_link_libraries(kdevelop "-framework CoreFoundation")
ENDIF()

install(TARGETS kdevelop ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES kdevelop! DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)

if (WIN32)
install(FILES windows/kdevelop-msvc.bat DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
endif (WIN32)

if (APPLE)
    # the MacOSX bundle display name property (CFBundleDisplayName) is not currently supported by cmake,
    # so has to be set for all targets in this cmake file
    set(MACOSX_BUNDLE_DISPLAY_NAME KDevelop)
    # We provide our own Info.plist to disable AppNap for KDevelop:
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in)
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.KDevelop")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDevelop")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_DISPLAY_NAME "KDevelop")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_INFO_STRING "The KDevelop Integrated Development Environment")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_LONG_VERSION_STRING "KDevelop ${KDEVELOP_VERSION_MAJOR}.${KDEVELOP_VERSION_MINOR}")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_SHORT_VERSION_STRING "${KDEVELOP_VERSION_MAJOR}.${KDEVELOP_VERSION_MINOR}")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_BUNDLE_VERSION "${KDEVELOP_VERSION_MAJOR}.${KDEVELOP_VERSION_MINOR}")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_ICON_FILE "kdevelop_SRCS.icns")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_COPYRIGHT "KDevelop Team")
endif (APPLE)


########### install files ###############

install( PROGRAMS org.kde.kdevelop.desktop  DESTINATION  ${KDE_INSTALL_APPDIR} )
install( PROGRAMS org.kde.kdevelop_ps.desktop  DESTINATION  ${KDE_INSTALL_APPDIR} )
install( FILES kdevelop.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFY5RCDIR} )
install( FILES kdevelop.xml kdevelopinternal.xml DESTINATION ${KDE_INSTALL_MIMEDIR} )
update_xdg_mimetypes( ${KDE_INSTALL_MIMEDIR} )

=== app_templates/CMakeLists.txt ===
kdevplatform_add_app_templates(
    cpp/CMake/cmake_plaincpp
    cpp/CMake/cmake_qt4core
    cpp/CMake/cmake_qt4core_qtest
    cpp/CMake/cmake_qt4gui
    cpp/CMake/cmake_qt5guiapp
    cpp/QMake/qmake_qt4guiapp
    cpp/QMake/qt5-qml2
)

=== file_templates/CMakeLists.txt ===
set(filetemplate_DIRS
    classes/cpp_basic
    classes/private_pointer
    classes/qt_widget
    classes/qobject
    classes/python_basic
    classes/c_gobject
    classes/c_gobject_private
    classes/c_gobject_properties
    classes/qt_shared

    testing/cpp_cpputest
    testing/cpp_gtest
    testing/cpp_qtestlib
    testing/cpp_qtestlib_kde
    testing/cpp_qtestlib_kdevelop
    testing/python_pyunit
    testing/php_phpunit

    other/cmake_module
)

kdevplatform_add_file_templates(${filetemplate_DIRS})

install ( FILES
    common/method_declaration_cpp.txt
    common/method_definition_cpp.txt
    common/license_header_cpp.txt
    common/class_declaration_cpp.txt
    common/cpp_header.h
    common/cpp_header_onlyfunctions.h
    common/cpp_implementation.cpp
    DESTINATION ${DATA_INSTALL_DIR}/kdevcodegen/templates
)

=== languages/CMakeLists.txt ===
ecm_optional_add_subdirectory(plugins)
ecm_optional_add_subdirectory(qmljs)

option(LEGACY_CPP_SUPPORT "Enable legacy C++ backend" OFF)

if(LEGACY_CPP_SUPPORT)
    ecm_optional_add_subdirectory(cpp)
else()
    find_package(Clang 3.5)
    set_package_properties(Clang PROPERTIES
        PURPOSE "Clang libraries. Used for KDevelop's C++/C support plugin. Please install a package providing libclang."
        TYPE REQUIRED
    )

    if (CLANG_FOUND)
        if (NOT CLANG_LIBCLANG_LIB)
            message(FATAL_ERROR "Could not find the Clang C library: libclang")
        endif()

        ecm_optional_add_subdirectory(clang)
    endif()
endif()

=== utils/CMakeLists.txt ===
find_package(OktetaKastenControllers 0.3.1)
set_package_properties(OktetaKastenControllers PROPERTIES
    PURPOSE "Required for building Okteta KDevelop plugin."
    URL "http://kde.org/"
    TYPE OPTIONAL)

if (OktetaKastenControllers_FOUND)
    find_package( KastenControllers )

    set_package_properties(KastenControllers PROPERTIES
        PURPOSE "Required for building Okteta KDevelop plugin."
        URL "http://kde.org/"
        TYPE OPTIONAL)
endif()

if (OktetaKastenControllers_FOUND AND KastenControllers_FOUND)
    add_subdirectory(okteta)
endif()

=== documentation/qthelp/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevqthelp\")

set(kdevqthelp_SRCS
    qthelpplugin.cpp
    qthelpproviderabstract.cpp
    qthelpprovider.cpp
    qthelpdocumentation.cpp
    qthelpqtdoc.cpp
    qthelp_config_shared.cpp
    debug.cpp
    qthelpconfig.cpp # Configuration module for QtHelp plugin
)

ki18n_wrap_ui(kdevqthelp_SRCS
    qthelpconfig.ui
    qthelpconfigeditdialog.ui
)

qt5_add_resources(kdevqthelp_SRCS kdevqthelp.qrc)
kdevplatform_add_plugin(kdevqthelp JSON kdevqthelp.json SOURCES ${kdevqthelp_SRCS})
target_link_libraries(kdevqthelp
    KF5::KCMUtils KF5::I18n KF5::KIOWidgets KF5::TextEditor KF5::IconThemes Qt5::Help KF5::NewStuff
    KDev::Language KDev::Documentation KDev::Interfaces)

add_subdirectory(tests)

=== formatters/customscript/CMakeLists.txt ===
########### indent ###############
set(kdevcustomscript_PART_SRCS
    customscript_plugin.cpp
)

kdevplatform_add_plugin(kdevcustomscript JSON kdevcustomscript.json SOURCES ${kdevcustomscript_PART_SRCS})
target_link_libraries(kdevcustomscript
    KDev::Interfaces
    KDev::Util)

=== languages/qmljs/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/libs
    ${KDevelop_SOURCE_DIR}/languages/plugins
)

add_definitions(-DQT_CREATOR) # :D
add_definitions(-DQML_BUILD_STATIC_LIB=1)

add_subdirectory(libs)
add_subdirectory(duchain)
add_subdirectory(nodejsmodules)
add_subdirectory(tests)
add_subdirectory(codecompletion)

kdevplatform_add_plugin(kdevqmljslanguagesupport JSON kdevqmljs.json SOURCES
    qmljsparsejob.cpp
    qmljshighlighting.cpp
    kdevqmljsplugin.cpp
    debug.cpp
    navigation/propertypreviewwidget.cpp
)
target_link_libraries(kdevqmljslanguagesupport
    kdevqmljsduchain
    kdevqmljscompletion
    Qt5::Widgets
    Qt5::QuickWidgets
    KF5::Declarative
)

install(DIRECTORY navigation/propertywidgets DESTINATION ${DATA_INSTALL_DIR}/kdevqmljssupport)

=== projectbuilders/ninjabuilder/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevninja\")
set(kdevninja_SRCS ninjajob.cpp kdevninjabuilderplugin.cpp ninjabuilderpreferences.cpp)
ki18n_wrap_ui(kdevninja_SRCS ninjaconfig.ui)
kconfig_add_kcfg_files(kdevninja_SRCS ninjabuilderconfig.kcfgc)

kdevplatform_add_plugin(kdevninja JSON kdevninja.json SOURCES ${kdevninja_SRCS})

target_link_libraries(kdevninja
    KDev::Interfaces
    KDev::Project
    KDev::OutputView
    KDev::Shell
    KDev::Util
)

=== projectmanagers/cmake/CMakeLists.txt ===
project(cmakemanager)
add_definitions(-DTRANSLATION_DOMAIN=\"kdevcmake\")
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/parser)

add_subdirectory(tests)
add_subdirectory(icons)

# enable this if you want to have the cmake debug visitor run on each CMakeLists.txt
# the debug visitor prints out the Ast for the CMakeLists.txt file.
#add_definitions( -DCMAKEDEBUGVISITOR )

add_definitions( -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)

set( cmakecommon_SRCS
  parser/cmListFileLexer.c
#   parser/astfactory.cpp
#   parser/cmakelistsparser.cpp
#   parser/cmakeast.cpp
#   parser/cmakecondition.cpp
#   parser/cmakeprojectvisitor.cpp
#   parser/variablemap.cpp
#   parser/cmakedebugvisitor.cpp
  parser/cmakecachereader.cpp
  parser/cmakelistsparser.cpp
  parser/cmakeduchaintypes.cpp
#   parser/cmakeparserutils.cpp
#   parser/cmakeduchaintypes.cpp
#   parser/generationexpressionsolver.cpp
  cmakeutils.cpp
  cmakebuilddirchooser.cpp
  debug.cpp

 )

set( cmakecommon_UI
  cmakebuilddirchooser.ui
)

set( cmakemanager_SRCS
  testing/ctestutils.cpp
  testing/ctestfindjob.cpp
  testing/ctestrunjob.cpp
  testing/ctestsuite.cpp
  testing/qttestdelegate.cpp
  cmakeimportjsonjob.cpp
  cmakenavigationwidget.cpp
  cmakemanager.cpp
  cmakemodelitems.cpp
  duchain/cmakeparsejob.cpp
  duchain/usebuilder.cpp
  duchain/declarationbuilder.cpp
  duchain/contextbuilder.cpp
  cmakecodecompletionmodel.cpp
#   cmakecommitchangesjob.cpp
#   cmakeimportjob.cpp
#   cmakeedit.cpp
  debug.cpp
)

set( cmakemanager_UI
  cmakepossibleroots.ui
)

set( cmakesettings_SRCS
  settings/cmakepreferences.cpp
  settings/cmakecachemodel.cpp
  settings/cmakecachedelegate.cpp
  settings/cmakecachemodel.cpp
  debug.cpp
)
ki18n_wrap_ui(cmakesettings_SRCS settings/cmakebuildsettings.ui)

set( cmakedoc_SRCS
  cmakedocumentation.cpp
  cmakehelpdocumentation.cpp
)

remove_definitions( -DQT_NO_STL )

if(WIN32)
    add_definitions(-DYY_NO_UNISTD_H)
endif()

# Note: This library doesn't follow API/ABI/BC rules and shouldn't have a SOVERSION
#       Its only purpose is to support the plugin without needing to add all source files
#       to the plugin target

ki18n_wrap_ui( cmakecommon_SRCS ${cmakecommon_UI} )
add_library( kdevcmakecommon SHARED ${cmakecommon_SRCS} )
target_link_libraries( kdevcmakecommon
                        KF5::TextEditor KDev::Interfaces KDev::Project KDev::Util
                        KDev::Language
                        )
generate_export_header(kdevcmakecommon EXPORT_FILE_NAME cmakecommonexport.h)

ki18n_wrap_ui( cmakemanager_SRCS ${cmakemanager_UI} )
add_library( kdevcmakemanagernosettings STATIC ${cmakemanager_SRCS})
target_link_libraries( kdevcmakemanagernosettings KF5::KIOWidgets KDev::Util
                        KDev::Interfaces kdevcmakecommon kdevmakefileresolver
                        KDev::Project KDev::Language
                        KDev::OutputView KF5::TextEditor Qt5::Concurrent)

kdevplatform_add_plugin(kdevcmakemanager JSON kdevcmakemanager.json SOURCES ${cmakemanager_SRCS} ${cmakesettings_SRCS})
target_link_libraries( kdevcmakemanager  KF5::KIOWidgets KDev::Util
                        KDev::Interfaces kdevcmakecommon kdevmakefileresolver
                        KDev::Project KDev::Language
                        KDev::OutputView KF5::TextEditor Qt5::Concurrent)

kdevplatform_add_plugin(kdevcmakedocumentation JSON kdevcmakedocumentation.json SOURCES ${cmakedoc_SRCS})
target_link_libraries( kdevcmakedocumentation
                        KDev::Interfaces kdevcmakecommon
                        KDev::Project KDev::Language
                        KDev::Documentation
                        KF5::TextEditor)

install(TARGETS kdevcmakecommon ${INSTALL_TARGETS_DEFAULT_ARGS} )

=== projectmanagers/custom-buildsystem/CMakeLists.txt ===
project(kdevelop4-custom-buildsystem)
add_definitions(-DTRANSLATION_DOMAIN=\"kdevcustombuildsystem\")
## Unittests
add_subdirectory( tests )

## KDevelop Plugin
set(custom_SRCS
    custombuildsystemconfig.cpp
    custombuildsystemplugin.cpp
    custombuildjob.cpp
    configwidget.cpp
    custombuildsystemconfigwidget.cpp
    kcm_custombuildsystem.cpp
    debugarea.cpp
)
ki18n_wrap_ui(custom_SRCS configwidget.ui custombuildsystemconfigwidget.ui)
kconfig_add_kcfg_files(custom_SRCS kcfg_custombuildsystemconfig.kcfgc )

kdevplatform_add_plugin(kdevcustombuildsystem JSON kdevcustombuildsystem.json SOURCES ${custom_SRCS})
target_link_libraries(kdevcustombuildsystem
      KDev::Project
      KDev::Interfaces
      KDev::Util
      KDev::OutputView
)

=== debian/changelog ===
kdevelop (4:5.0.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Bump kdevplatform-dev build-dependency version.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sat, 07 Jan 2017 16:23:12 -0300

kdevelop (4:5.0.1-3) unstable; urgency=medium

  * Bump llvm and clang build dependencies to 3.9. This avoids a crash when
    users are running video drivers compiled against llvm 3.9. Yes, it's a
    temporal fix only (Closes: #846410).

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Fri, 16 Dec 2016 09:41:42 -0300

=== debian/control ===
Source: kdevelop
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>,
           Jeremy Lainé <jeremy.laine@m4x.org>,
           George Kiagiadakis <kiagiadakis.george@gmail.com>,
           Andreas Cord-Landwehr <cola@uni-paderborn.de>
Build-Depends: cmake (>= 2.8.12),
               debhelper (>= 9),
               extra-cmake-modules (>= 0.0.9),
               qtbase5-dev (>= 5.4.0),
               qtdeclarative5-dev (>= 5.4.0),
               qttools5-dev,
               qttools5-dev-tools,
               libqt5webkit5-dev (>= 5.4.0),
               libkf5config-dev (>= 5.15.0),
               libkf5crash-dev (>= 5.15.0),
               libkf5declarative-dev (>= 5.15.0),
               libkf5doctools-dev (>= 5.15.0),
               libkf5iconthemes-dev (>= 5.15.0),
               libkf5i18n-dev (>= 5.15.0),
               libkf5itemmodels-dev (>= 5.15.0),
               libkf5itemviews-dev (>= 5.15.0),
               libkf5jobwidgets-dev (>= 5.15.0),
               libkf5kcmutils-dev (>= 5.15.0),
               libkf5kio-dev (>= 5.15.0),
               libkf5newstuff-dev (>= 5.15.0),
               libkf5notifyconfig-dev (>= 5.15.0),
               libkf5parts-dev (>= 5.15.0),
               libkf5service-dev (>= 5.15.0),
               libkf5texteditor-dev (>= 5.15.0),
               libkf5threadweaver-dev (>= 5.15.0),
               libkf5windowsystem-dev (>= 5.15.0),
               libkf5xmlgui-dev (>= 5.15.0),
               kdevelop-pg-qt (>= 2.0),
               kdevplatform-dev (>= 5.0.3),
               okteta-dev (>= 4:16.08.0-1~),
               libkf5sysguard-dev,
               libkf5plasma-dev [linux-any],
               libkf5runner-dev [linux-any],
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               shared-mime-info,
               llvm-3.9-dev,
               libclang-3.9-dev,
Standards-Version: 3.9.8
Homepage: http://www.kdevelop.org/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-std/kdevelop.git
Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-std/kdevelop.git

Package: kdevelop
Architecture: any
Depends: kdevelop-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: g++, gcc, gdb (>= 7.0), kapptemplate, make, kio-extras
Suggests: cmake, kdevelop-l10n, ninja-build
Description: integrated development environment for KDE
 KDevelop is an easy to use integrated development environment for KDE.
 It supports a wide range of programming languages and features project
 management, an advanced editor, a class browser and an integrated debugger.
 .
 The application wizard can generate fully functional projects
 for terminal programs and GUI programs using Qt, KDE or GNOME.

Package: kdevelop-data
Architecture: all
Depends: ${misc:Depends}
Breaks: kdevelop-doc (<< 4:4.3)
Replaces: kdevelop-doc (<< 4:4.3)
Description: data files for the KDevelop IDE
 KDevelop is an easy to use integrated development environment for KDE.
 It supports a wide range of programming languages and features project
 management, an advanced editor, a class browser and an integrated debugger.
 .
 The application wizard can generate fully functional projects
 for terminal programs and GUI programs using Qt, KDE or GNOME.
 .
 This package contains arch independent data for KDevelop.

Package: kdevelop-dev
Section: libdevel
Architecture: any
Depends: kdevelop (= ${binary:Version}),
         kdevplatform-dev (>= 5.0.1),
         ${misc:Depends}
Description: development files for the KDevelop IDE
 KDevelop is an easy to use integrated development environment for KDE.
 It supports a wide range of programming languages and features project
 management, an advanced editor, a class browser and an integrated debugger.
 .
 The application wizard can generate fully functional projects
 for terminal programs and GUI programs using Qt, KDE or GNOME.
 .
 This package contains development files for KDevelop.

Package: kdevelop-l10n
Section: localization
Architecture: all
Depends: kdevplatform-l10n,
         ${misc:Depends}
Replaces: kdevelop-l10n-ca,
          kdevelop-l10n-cavalencia,
          kdevelop-l10n-da,
          kdevelop-l10n-de,
          kdevelop-l10n-engb,
          kdevelop-l10n-es,
          kdevelop-l10n-et,
          kdevelop-l10n-fi,
          kdevelop-l10n-fr,
          kdevelop-l10n-gl,
          kdevelop-l10n-it,
          kdevelop-l10n-nds,
          kdevelop-l10n-nl,
          kdevelop-l10n-pt,
          kdevelop-l10n-ptbr,
          kdevelop-l10n-ru,
          kdevelop-l10n-sl,
          kdevelop-l10n-sv,
          kdevelop-l10n-th,
          kdevelop-l10n-tr,
          kdevelop-l10n-uk,
          kdevelop-l10n-zhcn,
          kdevelop-l10n-zhtw
Breaks: kdevelop-l10n-ca,
        kdevelop-l10n-cavalencia,
        kdevelop-l10n-da,
        kdevelop-l10n-de,
        kdevelop-l10n-engb,
        kdevelop-l10n-es,
        kdevelop-l10n-et,
        kdevelop-l10n-fi,
        kdevelop-l10n-fr,
        kdevelop-l10n-gl,
        kdevelop-l10n-it,
        kdevelop-l10n-nds,
        kdevelop-l10n-nl,
        kdevelop-l10n-pt,
        kdevelop-l10n-ptbr,
        kdevelop-l10n-ru,
        kdevelop-l10n-sl,
        kdevelop-l10n-sv,
        kdevelop-l10n-th,
        kdevelop-l10n-tr,
        kdevelop-l10n-uk,
        kdevelop-l10n-zhcn,
        kdevelop-l10n-zhtw
Description: localization files for the KDevelop IDE
 KDevelop is an easy to use integrated development environment for KDE.
 It supports a wide range of programming languages and features project
 management, an advanced editor, a class browser and an integrated debugger.
 .
 This package contains the translations for KDevelop.

Package: plasma-kdevelop
Architecture: linux-any
Depends: kdevelop (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: KDevelop plugins for Plasma
 KDevelop is an easy to use integrated development environment for KDE.
 It supports a wide range of programming languages and features project
 management, an advanced editor, a class browser and an integrated debugger.
 .
 This package contains the KDevelop plugins for integrating in the Plasma
 desktop environment:
  * sessions data engine
  * sessions widget
  * sessions KRunner module

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --parallel --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/man/out
	-rmdir debian/man

override_dh_auto_build:
	dh_auto_build --parallel
	if ! test -d debian/man/out; then mkdir -p debian/man/out; fi
	for f in $$(find debian/man -name '*.man'); do \
		soelim -I debian/man $$f \
		> debian/man/out/`basename $$f .man`.`head -n1 $$f | awk '{print $$NF}'`; \
	done

override_dh_install:
	dh_install --list-missing

override_dh_strip:
	dh_strip --dbgsym-migration='kdevelop-dbg (<< 4:4.7.3-3~)'

.PHONY: override_dh_auto_test

=== debian/watch ===
version=3
opts="repack,compression=xz"
http://download.kde.org/stable/kdevelop/([\d.]+)/src/kdevelop-([\d.]+).tar.(?:xz|bz2|gz)

## kdevelop 5.0.4

=== debian/changelog ===
kdevelop (4:5.0.4-0ubuntu2) zesty; urgency=medium

  [ Philip Muškovac ]
  * Revert the versioned clang dep - We don't have the mesa/llvm-default
    mismatch in ubuntu that caused debian bug #846410, so this only
    causes potential problems for us (LP: #1677140)

 -- Rik Mills <rikmills@kubuntu.org>  Thu, 30 Mar 2017 08:55:28 +0100

kdevelop (4:5.0.4-0ubuntu1) zesty; urgency=medium

  * New upstream bugfix release (5.0.4)
  * Sync with Debian. Remaining changes:
    - Breaks/replaces kapptemplate (<<4:15.12.3)
    - Depends on qml modules.

 -- Rik Mills <rikmills@kubuntu.org>  Wed, 15 Mar 2017 08:11:32 +0000

kdevelop (4:5.0.3-2) UNRELEASED; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Make kdevelop depend upon kinit, it's required to get KIO support
    (Closes: #851701). Thanks George Kiagiadakis for the bug report.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Wed, 18 Jan 2017 17:20:27 -0300

kdevelop (4:5.0.3-0ubuntu1) UNRELEASED; urgency=medium

  [ Clive Johnston ]
  * Porting to KF5
  * New upstream release (5.0)

  [ Ovidiu-Florin Bogdan ]
  * Added build depends for qttools5-dev-tools

  [ Clive Johnston ]
  * New upstream release (5.0.1)
  * Add breaks/replaces kapptemplate (<<4:15.12.3) as upstream moved
    some files from kapptemplate to kdevelop-data package, causing
    conflicts on installation. See kapptemplate git repo, commit #
    7e254781978eac082eb1d566a1c083920b8ea668
  * New upstream release (5.0.2)

  [ Simon Quigley ]
  * New upstream release (5.0.3)

 -- Clive Johnston <clivejo@kubuntu.org>  Wed, 28 Sep 2016 16:17:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: kdevelop
 Section: devel
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Fathi Boudra <fabo@debian.org>,
            Jeremy Lainé <jeremy.laine@m4x.org>,
            George Kiagiadakis <kiagiadakis.george@gmail.com>,
@@ -9,17 +10,15 @@
 Build-Depends: cmake (>= 2.8.12),
                debhelper (>= 9),
                extra-cmake-modules (>= 0.0.9),
-               qtbase5-dev (>= 5.4.0),
-               qtdeclarative5-dev (>= 5.4.0),
-               qttools5-dev,
-               qttools5-dev-tools,
-               libqt5webkit5-dev (>= 5.4.0),
+               kdevelop-pg-qt (>= 2.0),
+               kdevplatform-dev (>= 5.0.4),
+               libclang-dev,
                libkf5config-dev (>= 5.15.0),
                libkf5crash-dev (>= 5.15.0),
                libkf5declarative-dev (>= 5.15.0),
                libkf5doctools-dev (>= 5.15.0),
+               libkf5i18n-dev (>= 5.15.0),
                libkf5iconthemes-dev (>= 5.15.0),
-               libkf5i18n-dev (>= 5.15.0),
                libkf5itemmodels-dev (>= 5.15.0),
                libkf5itemviews-dev (>= 5.15.0),
                libkf5jobwidgets-dev (>= 5.15.0),
@@ -28,33 +27,40 @@
                libkf5newstuff-dev (>= 5.15.0),
                libkf5notifyconfig-dev (>= 5.15.0),
                libkf5parts-dev (>= 5.15.0),
+               libkf5plasma-dev [linux-any],
+               libkf5runner-dev [linux-any],
                libkf5service-dev (>= 5.15.0),
+               libkf5sysguard-dev,
                libkf5texteditor-dev (>= 5.15.0),
                libkf5threadweaver-dev (>= 5.15.0),
                libkf5windowsystem-dev (>= 5.15.0),
                libkf5xmlgui-dev (>= 5.15.0),
-               kdevelop-pg-qt (>= 2.0),
-               kdevplatform-dev (>= 5.0.3),
+               libqt5webkit5-dev (>= 5.4.0),
+               llvm-dev,
                okteta-dev (>= 4:16.08.0-1~),
-               libkf5sysguard-dev,
-               libkf5plasma-dev [linux-any],
-               libkf5runner-dev [linux-any],
                pkg-config,
                pkg-kde-tools (>= 0.15.16),
-               shared-mime-info,
-               llvm-3.9-dev,
-               libclang-3.9-dev,
+               qtbase5-dev (>= 5.4.0),
+               qtdeclarative5-dev (>= 5.4.0),
+               qttools5-dev,
+               qttools5-dev-tools,
+               shared-mime-info
+XS-Testsuite: autopkgtest
 Standards-Version: 3.9.8
 Homepage: http://www.kdevelop.org/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-std/kdevelop.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-std/kdevelop.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
+Vcs-Git: git://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
 
 Package: kdevelop
 Architecture: any
 Depends: kdevelop-data (>= ${source:Version}),
+         kinit,
+         plasma-framework,
+         qml-module-qtquick-controls,
+         qml-module-qtquick2,
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: g++, gcc, gdb (>= 7.0), kapptemplate, make, kio-extras
+Recommends: g++, gcc, gdb (>= 7.0), kapptemplate, kio-extras, make
 Suggests: cmake, kdevelop-l10n, ninja-build
 Description: integrated development environment for KDE
  KDevelop is an easy to use integrated development environment for KDE.
@@ -66,9 +72,12 @@
 
 Package: kdevelop-data
 Architecture: all
-Depends: ${misc:Depends}
-Breaks: kdevelop-doc (<< 4:4.3)
-Replaces: kdevelop-doc (<< 4:4.3)
+Depends: plasma-framework,
+         qml-module-qtquick-controls,
+         qml-module-qtquick2,
+         ${misc:Depends}
+Breaks: kapptemplate (<<4:15.12.3), kdevelop-doc (<< 4:4.3)
+Replaces: kapptemplate (<<4:15.12.3), kdevelop-doc (<< 4:4.3)
 Description: data files for the KDevelop IDE
  KDevelop is an easy to use integrated development environment for KDE.
  It supports a wide range of programming languages and features project
@@ -83,7 +92,7 @@
 Section: libdevel
 Architecture: any
 Depends: kdevelop (= ${binary:Version}),
-         kdevplatform-dev (>= 5.0.1),
+         kdevplatform-dev (>= 5.0.4),
          ${misc:Depends}
 Description: development files for the KDevelop IDE
  KDevelop is an easy to use integrated development environment for KDE.
@@ -98,8 +107,7 @@
 Package: kdevelop-l10n
 Section: localization
 Architecture: all
-Depends: kdevplatform-l10n,
-         ${misc:Depends}
+Depends: kdevplatform-l10n, ${misc:Depends}
 Replaces: kdevelop-l10n-ca,
           kdevelop-l10n-cavalencia,
           kdevelop-l10n-da,
@@ -146,6 +154,7 @@
         kdevelop-l10n-uk,
         kdevelop-l10n-zhcn,
         kdevelop-l10n-zhtw
+Recommends: kdevplatform-l10n
 Description: localization files for the KDevelop IDE
  KDevelop is an easy to use integrated development environment for KDE.
  It supports a wide range of programming languages and features project
@@ -155,9 +164,7 @@
 
 Package: plasma-kdevelop
 Architecture: linux-any
-Depends: kdevelop (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
+Depends: kdevelop (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: KDevelop plugins for Plasma
  KDevelop is an easy to use integrated development environment for KDE.
  It supports a wide range of programming languages and features project
